/*

 dct36_3dnow.s - 3DNow! optimized dct36()

 This code based 'dct36_3dnow.s' by Syuuhei Kashiyama
 <squash@mb.kcom.ne.jp>,only two types of changes have been made:

 - remove PREFETCH instruction for speedup
 - change function name for support 3DNow! automatic detect

 You can find Kashiyama's original 3dnow! support patch
 (for mpg123-0.59o) at
 http://user.ecc.u-tokyo.ac.jp/~g810370/linux-simd/ (Japanese).

 by KIMURA Takuhiro <kim@hannah.ipc.miyakyo-u.ac.jp> - until 31.Mar.1999
                    <kim@comtec.co.jp>               - after  1.Apr.1999


 Replacement of dct36() with AMD's 3DNow! SIMD operations support

 Syuuhei Kashiyama <squash@mb.kcom.ne.jp>

 The author of this program disclaim whole expressed or implied
 warranties with regard to this program, and in no event shall the
 author of this program liable to whatever resulted from the use of
 this program. Use it at your own risk.
 
 Inline asm by Nick Kurshev <nickols_k@mail.ru>
*/
#include "mpg123.h"
#include "../../mplayerxp/mangle.h"
#include "../../mplayerxp/cpudetect.h"
extern real COS9[9];
extern real tfcos36[9];
void dct36_3dnow(real *a,real *b,real *c,real *d,real *e)
{
    __asm __volatile(
"	femms\n\t"

"	movq (%0),%%mm0\n\t"
"	movq 4(%0),%%mm1\n\t"
"	pfadd %%mm1,%%mm0\n\t"
"	movq %%mm0,4(%0)\n\t"
"	psrlq $32,%%mm1\n\t"
"	movq 12(%0),%%mm2\n\t"
"	punpckldq %%mm2,%%mm1\n\t"
"	pfadd %%mm2,%%mm1\n\t"
"	movq %%mm1,12(%0)\n\t"
"	psrlq $32,%%mm2\n\t"
"	movq 20(%0),%%mm3\n\t"
"	punpckldq %%mm3,%%mm2\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movq %%mm2,20(%0)\n\t"
"	psrlq $32,%%mm3\n\t"
"	movq 28(%0),%%mm4\n\t"
"	punpckldq %%mm4,%%mm3\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movq %%mm3,28(%0)\n\t"
"	psrlq $32,%%mm4\n\t"
"	movq 36(%0),%%mm5\n\t"
"	punpckldq %%mm5,%%mm4\n\t"
"	pfadd %%mm5,%%mm4\n\t"
"	movq %%mm4,36(%0)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movq 44(%0),%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movq %%mm5,44(%0)\n\t"
"	psrlq $32,%%mm6\n\t"
"	movq 52(%0),%%mm7\n\t"
"	punpckldq %%mm7,%%mm6\n\t"
"	pfadd %%mm7,%%mm6\n\t"
"	movq %%mm6,52(%0)\n\t"
"	psrlq $32,%%mm7\n\t"
"	movq 60(%0),%%mm0\n\t"
"	punpckldq %%mm0,%%mm7\n\t"
"	pfadd %%mm0,%%mm7\n\t"
"	movq %%mm7,60(%0)\n\t"
"	psrlq $32,%%mm0\n\t"
"	movd 68(%0),%%mm1\n\t"
"	pfadd %%mm1,%%mm0\n\t"
"	movd %%mm0,68(%0)\n\t"
"	movd 4(%0),%%mm0\n\t"
"	movd 12(%0),%%mm1\n\t"
"	punpckldq %%mm1,%%mm0\n\t"
"	punpckldq 20(%0),%%mm1\n\t"
"	pfadd %%mm1,%%mm0\n\t"
"	movd %%mm0,12(%0)\n\t"
"	psrlq $32,%%mm0\n\t"
"	movd %%mm0,20(%0)\n\t"
"	psrlq $32,%%mm1\n\t"
"	movd 28(%0),%%mm2\n\t"
"	punpckldq %%mm2,%%mm1\n\t"
"	punpckldq 36(%0),%%mm2\n\t"
"	pfadd %%mm2,%%mm1\n\t"
"	movd %%mm1,28(%0)\n\t"
"	psrlq $32,%%mm1\n\t"
"	movd %%mm1,36(%0)\n\t"
"	psrlq $32,%%mm2\n\t"
"	movd 44(%0),%%mm3\n\t"
"	punpckldq %%mm3,%%mm2\n\t"
"	punpckldq 52(%0),%%mm3\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movd %%mm2,44(%0)\n\t"
"	psrlq $32,%%mm2\n\t"
"	movd %%mm2,52(%0)\n\t"
"	psrlq $32,%%mm3\n\t"
"	movd 60(%0),%%mm4\n\t"
"	punpckldq %%mm4,%%mm3\n\t"
"	punpckldq 68(%0),%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movd %%mm3,60(%0)\n\t"
"	psrlq $32,%%mm3\n\t"
"	movd %%mm3,68(%0)\n\t"
	::"r"(a)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movq 24(%0),%%mm0\n\t"
"	movq 48(%0),%%mm1\n\t"
"	movd 12(%1),%%mm2\n\t"
"	punpckldq %%mm2,%%mm2\n\t"
"	movd 24(%1),%%mm3\n\t"
"	punpckldq %%mm3,%%mm3\n\t"
"	pfmul %%mm2,%%mm0\n\t"
"	pfmul %%mm3,%%mm1\n\t"
"	mov $1,%%"REG_a"\n\t"
"	movd %%"REG_a",%%mm7\n\t"
"	pi2fd %%mm7,%%mm7\n\t"
"	movq 8(%0),%%mm2\n\t"
"	movd 4(%1),%%mm3\n\t"
"	punpckldq %%mm3,%%mm3\n\t"
"	pfmul %%mm3,%%mm2\n\t"
"	pfadd %%mm0,%%mm2\n\t"
"	movq 40(%0),%%mm3\n\t"
"	movd 20(%1),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movq 56(%0),%%mm3\n\t"
"	movd 28(%1),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movq (%0),%%mm3\n\t"
"	movq 16(%0),%%mm4\n\t"
"	movd 8(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movq 32(%0),%%mm4\n\t"
"	movd 16(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	pfadd %%mm1,%%mm3\n\t"
"	movq 64(%0),%%mm4\n\t"
"	movd 32(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movq %%mm2,%%mm4\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq (%2),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
	::"r"(a),"r"(COS9),"r"(tfcos36)
	:"memory","%"REG_a
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movd 108(%2),%%mm6\n\t"
"	punpckldq 104(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,36(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,32(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 32(%2),%%mm6\n\t"
"	punpckldq 36(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 32(%0),%%mm6\n\t"
"	punpckldq 36(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,1024(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1152(%3)\n\t"
"	movq %%mm3,%%mm4\n\t"
"	pfsub %%mm2,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 32(%4),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 140(%2),%%mm6\n\t"
"	punpckldq 72(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,68(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,0(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd (%2),%%mm6\n\t"
"	punpckldq 68(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd (%0),%%mm6\n\t"
"	punpckldq 68(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,0(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,2176(%3)\n\t"
	::"r"(b),"r"(c),"r"(d),"r"(e),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movq 8(%0),%%mm2\n\t"
"	movq 40(%0),%%mm3\n\t"
"	pfsub %%mm3,%%mm2\n\t"
"	movq 56(%0),%%mm3\n\t"
"	pfsub %%mm3,%%mm2\n\t"
"	movd 12(%1),%%mm3\n\t"
"	punpckldq %%mm3,%%mm3\n\t"
"	pfmul %%mm3,%%mm2\n\t"
"	movq 16(%0),%%mm3\n\t"
"	movq 32(%0),%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movq 64(%0),%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movd 24(%1),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	movq 48(%0),%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movq (%0),%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movq %%mm2,%%mm4\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 4(%2),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
	::"r"(a),"r"(COS9),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movd 112(%2),%%mm6\n\t"
"	punpckldq 100(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,40(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,28(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 28(%2),%%mm6\n\t"
"	punpckldq 40(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 28(%0),%%mm6\n\t"
"	punpckldq 40(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,896(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1280(%3)\n\t"
"	movq %%mm3,%%mm4\n\t"
"	pfsub %%mm2,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 28(%4),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 136(%2),%%mm6\n\t"
"	punpckldq 76(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,64(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,4(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 4(%2),%%mm6\n\t"
"	punpckldq 64(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 4(%0),%%mm6\n\t"
"	punpckldq 64(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,128(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,2048(%3)\n\t"
	::"r"(b),"r"(c),"r"(d),"r"(e),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movq 8(%0),%%mm2\n\t"
"	movd 20(%1),%%mm3\n\t"
"	punpckldq %%mm3,%%mm3\n\t"
"	pfmul %%mm3,%%mm2\n\t"
"	pfsub %%mm0,%%mm2\n\t"
"	movq 40(%0),%%mm3\n\t"
"	movd 28(%1),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfsub %%mm3,%%mm2\n\t"
"	movq 56(%0),%%mm3\n\t"
"	movd 4(%1),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movq (%0),%%mm3\n\t"
"	movq 16(%0),%%mm4\n\t"
"	movd 32(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movq 32(%0),%%mm4\n\t"
"	movd 8(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	pfadd %%mm1,%%mm3\n\t"
"	movq 64(%0),%%mm4\n\t"
"	movd 16(%1),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	movq %%mm2,%%mm4\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 8(%2),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
	::"r"(a),"r"(COS9),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movd 116(%2),%%mm6\n\t"
"	punpckldq 96(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,44(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,24(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 24(%2),%%mm6\n\t"
"	punpckldq 44(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 24(%0),%%mm6\n\t"
"	punpckldq 44(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,768(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1408(%3)\n\t"
"	movq %%mm3,%%mm4\n\t"
"	pfsub %%mm2,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 24(%4),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 132(%2),%%mm6\n\t"
"	punpckldq 80(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,60(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,8(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 8(%2),%%mm6\n\t"
"	punpckldq 60(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
	::"r"(b),"r"(c),"r"(d),"r"(e),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movd 8(%1),%%mm6\n\t"
"	punpckldq 60(%1),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,256(%2)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1920(%2)\n\t"
"	movq 8(%0),%%mm2\n\t"
"	movd 28(%3),%%mm3\n\t"
"	punpckldq %%mm3,%%mm3\n\t"
"	pfmul %%mm3,%%mm2\n\t"
"	pfsub %%mm0,%%mm2\n\t"
"	movq 40(%0),%%mm3\n\t"
"	movd 4(%3),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfadd %%mm3,%%mm2\n\t"
"	movq 56(%0),%%mm3\n\t"
"	movd 20(%3),%%mm4\n\t"
"	punpckldq %%mm4,%%mm4\n\t"
"	pfmul %%mm4,%%mm3\n\t"
"	pfsub %%mm3,%%mm2\n\t"
"	movq (%0),%%mm3\n\t"
"	movq 16(%0),%%mm4\n\t"
"	movd 16(%3),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movq 32(%0),%%mm4\n\t"
"	movd 32(%3),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfadd %%mm4,%%mm3\n\t"
"	pfadd %%mm1,%%mm3\n\t"
"	movq 64(%0),%%mm4\n\t"
"	movd 8(%3),%%mm5\n\t"
"	punpckldq %%mm5,%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	pfsub %%mm4,%%mm3\n\t"
"	movq %%mm2,%%mm4\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
	::"r"(a),"r"(b),"r"(e),"r"(COS9)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	punpckldq 12(%4),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 120(%2),%%mm6\n\t"
"	punpckldq 92(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,48(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,20(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 20(%2),%%mm6\n\t"
"	punpckldq 48(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 20(%0),%%mm6\n\t"
"	punpckldq 48(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,640(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1536(%3)\n\t"
"	movq %%mm3,%%mm4\n\t"
"	pfsub %%mm2,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 20(%4),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 128(%2),%%mm6\n\t"
"	punpckldq 84(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,56(%1)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,12(%1)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 12(%2),%%mm6\n\t"
"	punpckldq 56(%2),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 12(%0),%%mm6\n\t"
"	punpckldq 56(%0),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,384(%3)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1792(%3)\n\t"
	::"r"(b),"r"(c),"r"(d),"r"(e),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);

    __asm __volatile(
"	movq (%0),%%mm4\n\t"
"	movq 16(%0),%%mm3\n\t"
"	pfsub %%mm3,%%mm4\n\t"
"	movq 32(%0),%%mm3\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq 48(%0),%%mm3\n\t"
"	pfsub %%mm3,%%mm4\n\t"
"	movq 64(%0),%%mm3\n\t"
"	pfadd %%mm3,%%mm4\n\t"
"	movq %%mm7,%%mm5\n\t"
"	punpckldq 16(%5),%%mm5\n\t"
"	pfmul %%mm5,%%mm4\n\t"
"	movq %%mm4,%%mm5\n\t"
"	pfacc %%mm5,%%mm5\n\t"
"	movd 124(%3),%%mm6\n\t"
"	punpckldq 88(%3),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd %%mm5,52(%2)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,16(%2)\n\t"
"	movq %%mm4,%%mm6\n\t"
"	punpckldq %%mm6,%%mm5\n\t"
"	pfsub %%mm6,%%mm5\n\t"
"	punpckhdq %%mm5,%%mm5\n\t"
"	movd 16(%3),%%mm6\n\t"
"	punpckldq 52(%3),%%mm6\n\t"
"	pfmul %%mm6,%%mm5\n\t"
"	movd 16(%1),%%mm6\n\t"
"	punpckldq 52(%1),%%mm6\n\t"
"	pfadd %%mm6,%%mm5\n\t"
"	movd %%mm5,512(%4)\n\t"
"	psrlq $32,%%mm5\n\t"
"	movd %%mm5,1664(%4)\n\t"
"	femms"
	::"r"(a),"r"(b),"r"(c),"r"(d),"r"(e),"r"(tfcos36)
	:"memory"
#ifdef FPU_CLOBBERED
	,FPU_CLOBBERED
#endif
#ifdef MMX_CLOBBERED
	,MMX_CLOBBERED
#endif
	);
}
